part of viltage;

class CharNode {
  int x, y;
  String char = "x";
  String color;
  String backgroundColor;
  List<String> classes = new List<String>();
  Map<String, String> attributes = new Map<String, String>();
  Map<String, String> styles = new Map<String, String>();
  SpanElement se = new SpanElement();
    
  StringBuffer _sbClasses, _sbStyles;
  
  CharNode(this.x, this.y, this.char) { 
    classes.add("char_node");
    _sbClasses = new StringBuffer();
    _sbStyles = new StringBuffer();
  }
  
  SpanElement getSpanElement() {
    se.attributes = attributes;
    se.classes = classes;
    
    if(backgroundColor != null) se.style.backgroundColor = backgroundColor;
    if(color != null) se.style.color = color;
    
    _sbStyles = new StringBuffer();
    styles.forEach((k, v) {
      _sbStyles.write("$k: $v;");
    });
    
    se.attributes["style"] = _sbStyles.toString();
    
    se.text = this.char;
    if(this.char == " " || this.char == "" || this.char.length > 1) se.text = "&nbsp;";
    
    return se;
  }
}